/* 
 * Automotive demo using 32 bit SDRAM. 
 * 
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <stdbool.h>
#include "system.h"

#include "lcd.h"
#include "draw.h"
#include "terminal.h"
#include "bitmap.h"
#include "alt_types.h"
#include "sys/alt_irq.h"
#include "sys/alt_alarm.h"
#include "sys/alt_cache.h"
#include "auto32.h"




void wait(int frames);
void back_fade(short *frameBuffer, int fade_frames, int inOut);



short fb0[FRAMEBUFFERSIZE] __attribute__ ((aligned(128)));


short* frameBuffer0;


unsigned char fb10[FRAMEBUFFERSIZE] __attribute__ ((aligned(128)));
unsigned char fb11[FRAMEBUFFERSIZE] __attribute__ ((aligned(128)));
unsigned char fb12[FRAMEBUFFERSIZE] __attribute__ ((aligned(128)));
unsigned char* frameBuffer10;
unsigned char* frameBuffer11;
unsigned char* frameBuffer12;

short *buffers[3];
int bufferWidth[3];
int bufferHeight[3];

LCDCONTROLLER lcd;
FILE *bmpFile;
vga_terminal terminal;


    
int main()
{ 


  // Remap all frame buffers to uncached regions
  frameBuffer0 = (short*)alt_remap_uncached(fb0, FRAMEBUFFERSIZE*2);
  IOWR_LCD_INT_CLR(0x1);
  // Register Videoin & lcd interrupt handlers
  alt_u32 dummy;
  alt_irq_register(LCD_CONTROLLER_0_IRQ, &dummy, lcdIsr);
  lcd_reset();


  // Load 16 bitbackground image into frame buffer 3
  bmpFile = fopen("/mnt/rozipfs/2c5.bmp","rb");
  
   if ((bmpFile  )== NULL) 
   {
    printf("Unable to open *.bmp\n");
    return -1;
  }
   else
   {
   bmpTo565(bmpFile, frameBuffer0);

   }    
    while(1)
{
  

  lcd_sync();
  lcdDoDMA(0, frameBuffer0, SCREENSIZE, 0x3f);
  lcdLayers(0x1); //start to light
  wait(240);
  //back_fade(frameBuffer0, EFFECTFRAMES, OUT);
  //wait(10);

}   

   exit(1);
  return 0;
  
}

volatile int lcdOwn;
volatile int lcdFlags;
int frames;


/*
 * Fade in background image on layer 1
 * 
 * Backgroung layer (0) does not have layer alpha so we have to use
 * layer 1 to do the fading and then display it from layer 0
 */
void back_fade(short *frameBuffer, int fade_frames, int inOut) {
  int initAlpha;
  int frames;
  int alphaFraction;
  
  lcd_sync();

//  videoInScale(4096, 4096);

  // videoin is disabled so all layers point at background
  buffers[0] = frameBuffer;
  buffers[1] = frameBuffer;
  buffers[2] = frameBuffer;
//here 1
  // Set up DMA for background using layer 1
  if (inOut == IN) {initAlpha = 0;} else {initAlpha = 0x3f;}
  lcdDoDMA(1, frameBuffer, SCREENSIZE, initAlpha);

  // initialize frame buffer ownership bits
 // videoOwn = 2;
  lcdOwn = 0;
  
  // Turn on layer 1 to use for fading
  //lcd_sync();
  lcdLayers(0x2);   //????
  
  // Enable interrupts
  IOWR_LCD_INT_EN(0x1);

  frames = 0;
  while (frames <= fade_frames) {
    while ((lcdFlags & 0x1) == 0){}

    alphaFraction = (frames*1024)/fade_frames;
    if (inOut == IN) {
      lcd.const_alpha1 = (MAXVIDEOALPHA * alphaFraction)/1024;
    } else {
      lcd.const_alpha1 = (MAXVIDEOALPHA * (1024 - alphaFraction))/1024;
    }
    lcdFlags = lcdFlags & 0xfffffffe;
    frames++;

  }
//here 4
  lcd_sync();
  if (inOut == IN) {
    // Leave background image on layer 0
    lcdDoDMA(0, frameBuffer, SCREENSIZE, 0x3f);
    lcdLayers(0x1); //start to light
  } else {
    // All layers off
    lcdLayers(0x0);
  }
}





/*
 * Wait for a number of LCD frames
 */
void wait(int frames) {
  int i = 0;
  int oldInt = IORD_LCD_INT_EN;
  // Enable interrupts
  IOWR_LCD_INT_EN(oldInt | 0x1);
      
  while (i < frames) {
    while ((lcdFlags & 0x1) == 0) {}
    lcdFlags = lcdFlags & 0xfffffffe;
    i++;
  }
  // Disable interrupts
  IOWR_LCD_INT_EN(oldInt);
}


