#ifndef __TERMINAL_H
#define __TERMINAL_H

#include "lcd.h"
#include "alt_types.h"
#include "draw.h"

typedef struct {
  alt_u32 rows;
  alt_u32 columns;
  alt_u32 cursorx;
  alt_u32 cursory;
  alt_u8 back_index;
  alt_u8 text_index;
  alt_u8* font;
  alt_u32 font_size;
  alt_u32 xstart;
  alt_u32 ystart;
  alt_u32 xend;
  alt_u32 yend;
  alt_u32 border;
  alt_u8 border_index;
  alt_u8* frameBuffer;
} vga_terminal;
  
int vga_term_init(alt_u32 xstart, alt_u32 xend, alt_u32 columns, alt_u32 rows, alt_u32 font_size, alt_u8 back_index, alt_u8 text_index, alt_u32 border, alt_u8 border_index, alt_u8* frameBuffer);

void vga_term_set_text(alt_u8 text_index);
  
void vga_term_set_back(alt_u8 back_index);
  
void vga_term_set_cursor(alt_u32 cursorx, alt_u32 cursory);

point vga_term_get_cursor(void);

void vga_term_cls();

void vga_term_print(char text[]);

void vga_term_newline();
  
#endif /* __TERMINAL_H */

